searchNodes=[{"doc":"Official SDK for interacting with Knock. Example usage As a module The recommended way to configure Knock is as a module in your application. Doing so will allow you to customize the options via configuration in your app. # lib/my_app/knock.ex defmodule MyApp.Knock do use Knock , otp_app : :my_app end # config/runtime.exs config :my_app , MyApp.KnockClient , api_key : System . get_env ( &quot;KNOCK_API_KEY&quot; ) In your application you can now execute commands on your configured Knock instance. client = MyApp.Knock . client ( ) { :ok , user } = Knock.Users . get_user ( client , &quot;user_1&quot; ) Invoking directly Optionally you can forgo implementing your own Knock module and create client instances manually: client = Knock.Client . new ( api_key : &quot;sk_test_12345&quot; ) Customizing options Out of the box the client will specify Tesla and Jason as the HTTP adapter and JSON client, respectively. However, you can customize this at will: config :my_app , Knock , adapter : Tesla.Adapter.Finch , json_client : JSX You can read more about the availble adapters in the Tesla documentation","ref":"Knock.html","title":"Knock","type":"module"},{"doc":"Issues a notify call, triggering a workflow with the given key.","ref":"Knock.html#notify/4","title":"Knock.notify/4","type":"function"},{"doc":"Api client for interacting with Knock","ref":"Knock.Api.html","title":"Knock.Api","type":"module"},{"doc":"Executes a delete request against the Knock api.","ref":"Knock.Api.html#delete/3","title":"Knock.Api.delete/3","type":"function"},{"doc":"Executes a get request against the Knock api.","ref":"Knock.Api.html#get/3","title":"Knock.Api.get/3","type":"function"},{"doc":"Returns the current version for the library","ref":"Knock.Api.html#library_version/0","title":"Knock.Api.library_version/0","type":"function"},{"doc":"Executes a post request against the Knock api.","ref":"Knock.Api.html#post/4","title":"Knock.Api.post/4","type":"function"},{"doc":"Executes a put request against the Knock api","ref":"Knock.Api.html#put/4","title":"Knock.Api.put/4","type":"function"},{"doc":"Defines available options to pass to an API function","ref":"Knock.Api.html#t:options/0","title":"Knock.Api.options/0","type":"type"},{"doc":"Describes a response from calling an API function","ref":"Knock.Api.html#t:response/0","title":"Knock.Api.response/0","type":"type"},{"doc":"Knock resources for accessing Bulk Operations","ref":"Knock.BulkOperations.html","title":"Knock.BulkOperations","type":"module"},{"doc":"Retrieves the current status of the bulk operation","ref":"Knock.BulkOperations.html#get/2","title":"Knock.BulkOperations.get/2","type":"function"},{"doc":"Knock resources for accessing channels","ref":"Knock.Channels.html","title":"Knock.Channels","type":"module"},{"doc":"Bulk updates channel's messages with provided action. Supports filtering messages to be updated with the following options: tenants: Scope messages to the list of tenant ids has_tenant: Scope to where either do or do not have a tenant present recipient_ids: Scope messages to the list of recipient ids engagement_status: Scope messages by engagements status: read, unread, seen, unseen, archived, unarchived, interacted, link_clicked archived: scopes to a particular type of archival status, one of exclude, include, only delivery_status: scope to only messages by delivery status, these can be the following: queued, sent, undelivered, delivery_attempted, delivered older_than: scope to only messages that were created before provided date newer_than: scope to only messages that were created after provided date","ref":"Knock.Channels.html#bulk_set_messages_status/4","title":"Knock.Channels.bulk_set_messages_status/4","type":"function"},{"doc":"Sets up a configurable client that can interface with the Knock API. Expects at least an API key to be provided. Example usage # Setup a client instance directly client = Knock.Client . new ( api_key : &quot;sk_test_12345&quot; )","ref":"Knock.Client.html","title":"Knock.Client","type":"module"},{"doc":"Creates a new client struct with the provided options. The options provided must at least contain an API secret key, which can be obtained in the Knock dashboard.","ref":"Knock.Client.html#new/1","title":"Knock.Client.new/1","type":"function"},{"doc":"Describes a Knock client","ref":"Knock.Client.html#t:t/0","title":"Knock.Client.t/0","type":"type"},{"doc":"Knock resources for accessing messages","ref":"Knock.Messages.html","title":"Knock.Messages","type":"module"},{"doc":"Returns information about the message content in batches.","ref":"Knock.Messages.html#batch_get_content/2","title":"Knock.Messages.batch_get_content/2","type":"function"},{"doc":"Batch update messages statuses: seen, read, interacted, archived, unseen, unread, unarchived","ref":"Knock.Messages.html#batch_set_status/3","title":"Knock.Messages.batch_set_status/3","type":"function"},{"doc":"Returns information about the message.","ref":"Knock.Messages.html#get/2","title":"Knock.Messages.get/2","type":"function"},{"doc":"Returns a paginated response with message's activities. Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination - trigger_data: filter activities by trigger payload data","ref":"Knock.Messages.html#get_activities/3","title":"Knock.Messages.get_activities/3","type":"function"},{"doc":"Returns information about the message content.","ref":"Knock.Messages.html#get_content/2","title":"Knock.Messages.get_content/2","type":"function"},{"doc":"Returns a paginated response with message's events. Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination","ref":"Knock.Messages.html#get_events/3","title":"Knock.Messages.get_events/3","type":"function"},{"doc":"Returns paginated messages for the provided environment Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination - status: list of statuses to filter messages with - tenant: tenant_id to filter messages with - channel_id: channel_id to filter messages with - source: workflow key to filter messages with - trigger_data: trigger payload to filter messages with","ref":"Knock.Messages.html#list/2","title":"Knock.Messages.list/2","type":"function"},{"doc":"Sets status of message: seen, read, archived","ref":"Knock.Messages.html#set_status/3","title":"Knock.Messages.set_status/3","type":"function"},{"doc":"Unsets status of message: unseen, unread, unarchived","ref":"Knock.Messages.html#unset_status/3","title":"Knock.Messages.unset_status/3","type":"function"},{"doc":"Knock resources for accessing Objects","ref":"Knock.Objects.html","title":"Knock.Objects","type":"module"},{"doc":"Adds subscriptions for all recipients passed as arguments Expected properties: recipients: list of recipients to create subscriptions for properties: data to be stored at the subscription level for each recipient","ref":"Knock.Objects.html#add_subscriptions/4","title":"Knock.Objects.add_subscriptions/4","type":"function"},{"doc":"Builds an object reference, which can be used in workflow trigger calls.","ref":"Knock.Objects.html#build_ref/2","title":"Knock.Objects.build_ref/2","type":"function"},{"doc":"Creates a bulk operation to create subscriptions for a set of recipients to a set of objects within the given collection. Each entry in the provided subscriptions list should have the properties: id: the id of an object for subscribing recipients: a list of recipients to subscribe to the object properties (optional): a map of properties to apply to each recipient subscription","ref":"Knock.Objects.html#bulk_add_subscriptions/3","title":"Knock.Objects.bulk_add_subscriptions/3","type":"function"},{"doc":"Bulk deletes one or more objects in a collection.","ref":"Knock.Objects.html#bulk_delete/3","title":"Knock.Objects.bulk_delete/3","type":"function"},{"doc":"Bulk upserts one or more objects in a collection.","ref":"Knock.Objects.html#bulk_set/3","title":"Knock.Objects.bulk_set/3","type":"function"},{"doc":"Deletes the given object.","ref":"Knock.Objects.html#delete/3","title":"Knock.Objects.delete/3","type":"function"},{"doc":"Delete subscriptions for recipients passed as arguments Expected properties: recipients: list of recipients to create subscriptions for","ref":"Knock.Objects.html#delete_subscriptions/4","title":"Knock.Objects.delete_subscriptions/4","type":"function"},{"doc":"Gets the given object.","ref":"Knock.Objects.html#get/3","title":"Knock.Objects.get/3","type":"function"},{"doc":"Returns all of the users preference sets","ref":"Knock.Objects.html#get_all_preferences/3","title":"Knock.Objects.get_all_preferences/3","type":"function"},{"doc":"Returns channel data for the given channel id.","ref":"Knock.Objects.html#get_channel_data/4","title":"Knock.Objects.get_channel_data/4","type":"function"},{"doc":"Returns paginated messages for the given object Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination - status: list of statuses to filter messages with - tenant: tenant_id to filter messages with - channel_id: channel_id to filter messages with - source: workflow key to filter messages with - trigger_data: trigger payload to filter messages with","ref":"Knock.Objects.html#get_messages/4","title":"Knock.Objects.get_messages/4","type":"function"},{"doc":"Returns the preference set for the user.","ref":"Knock.Objects.html#get_preferences/4","title":"Knock.Objects.get_preferences/4","type":"function"},{"doc":"Returns paginated schedules for the given object Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination - tenant: tenant_id to filter messages with - workflow: workflow key to filter messages with","ref":"Knock.Objects.html#get_schedules/4","title":"Knock.Objects.get_schedules/4","type":"function"},{"doc":"Returns paginated subscriptions for the given object as recipient Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination","ref":"Knock.Objects.html#get_subscriptions/4","title":"Knock.Objects.get_subscriptions/4","type":"function"},{"doc":"Returns paginated list of objects for a collection Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination","ref":"Knock.Objects.html#list/3","title":"Knock.Objects.list/3","type":"function"},{"doc":"Returns paginated subscriptions for the given object Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination - recipients: list of recipient identifiers to filter subscribers of the object","ref":"Knock.Objects.html#list_subscriptions/4","title":"Knock.Objects.list_subscriptions/4","type":"function"},{"doc":"Upserts the given object in the collection with the attrs provided.","ref":"Knock.Objects.html#set/4","title":"Knock.Objects.set/4","type":"function"},{"doc":"Sets the category preferences for the user.","ref":"Knock.Objects.html#set_categories_preferences/5","title":"Knock.Objects.set_categories_preferences/5","type":"function"},{"doc":"Sets the category preference for the user.","ref":"Knock.Objects.html#set_category_preferences/6","title":"Knock.Objects.set_category_preferences/6","type":"function"},{"doc":"Upserts channel data for the given channel id.","ref":"Knock.Objects.html#set_channel_data/5","title":"Knock.Objects.set_channel_data/5","type":"function"},{"doc":"Sets the channel type preference for the user.","ref":"Knock.Objects.html#set_channel_type_preferences/6","title":"Knock.Objects.set_channel_type_preferences/6","type":"function"},{"doc":"Sets the channel type preferences for the user.","ref":"Knock.Objects.html#set_channel_types_preferences/5","title":"Knock.Objects.set_channel_types_preferences/5","type":"function"},{"doc":"Sets an entire preference set for the user. Will overwrite any existing data.","ref":"Knock.Objects.html#set_preferences/5","title":"Knock.Objects.set_preferences/5","type":"function"},{"doc":"Sets the workflow preference for the user.","ref":"Knock.Objects.html#set_workflow_preferences/6","title":"Knock.Objects.set_workflow_preferences/6","type":"function"},{"doc":"Sets the workflow preferences for the user.","ref":"Knock.Objects.html#set_workflows_preferences/5","title":"Knock.Objects.set_workflows_preferences/5","type":"function"},{"doc":"Unsets the channel data for the given channel id.","ref":"Knock.Objects.html#unset_channel_data/4","title":"Knock.Objects.unset_channel_data/4","type":"function"},{"doc":"An object reference is how we refer to a particular object in a collection","ref":"Knock.Objects.html#t:ref/0","title":"Knock.Objects.ref/0","type":"type"},{"doc":"Knock resources for accessing preferences. Note: this module and all of the functions here are deprecated and will be removed in the next version.","ref":"Knock.Preferences.html","title":"Knock.Preferences","type":"module"},{"doc":"Returns the preference set for the user","ref":"Knock.Preferences.html#get/3","title":"Knock.Preferences.get/3","type":"function"},{"doc":"Returns all of the users preference sets","ref":"Knock.Preferences.html#get_all/2","title":"Knock.Preferences.get_all/2","type":"function"},{"doc":"Sets the entire preference set for the user","ref":"Knock.Preferences.html#set/4","title":"Knock.Preferences.set/4","type":"function"},{"doc":"Sets the workflow preferences for the user","ref":"Knock.Preferences.html#set_categories/4","title":"Knock.Preferences.set_categories/4","type":"function"},{"doc":"Sets the workflow preference for the user","ref":"Knock.Preferences.html#set_category/5","title":"Knock.Preferences.set_category/5","type":"function"},{"doc":"Sets the channel type preferences for the user","ref":"Knock.Preferences.html#set_channel_type/5","title":"Knock.Preferences.set_channel_type/5","type":"function"},{"doc":"Sets the channel type preferences for the user","ref":"Knock.Preferences.html#set_channel_types/4","title":"Knock.Preferences.set_channel_types/4","type":"function"},{"doc":"Sets the workflow preference for the user","ref":"Knock.Preferences.html#set_workflow/5","title":"Knock.Preferences.set_workflow/5","type":"function"},{"doc":"Sets the workflow preferences for the user","ref":"Knock.Preferences.html#set_workflows/4","title":"Knock.Preferences.set_workflows/4","type":"function"},{"doc":"","ref":"Knock.ResourceHelpers.html","title":"Knock.ResourceHelpers","type":"module"},{"doc":"Helpers for building resources API requests","ref":"Knock.ResourceHelpers.html#maybe_json_encode_param/2","title":"Knock.ResourceHelpers.maybe_json_encode_param/2","type":"function"},{"doc":"Represents a response back from Knock","ref":"Knock.Response.html","title":"Knock.Response","type":"module"},{"doc":"","ref":"Knock.Response.html#t:t/0","title":"Knock.Response.t/0","type":"type"},{"doc":"Knock resources for accessing Tenants","ref":"Knock.Tenants.html","title":"Knock.Tenants","type":"module"},{"doc":"Deletes the given tenant.","ref":"Knock.Tenants.html#delete/2","title":"Knock.Tenants.delete/2","type":"function"},{"doc":"Gets the given tenant.","ref":"Knock.Tenants.html#get/2","title":"Knock.Tenants.get/2","type":"function"},{"doc":"Returns paginated tenants for environment Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination - tenant_id: id of the tenant to filter for - name: name of the tenant to filter for","ref":"Knock.Tenants.html#list/2","title":"Knock.Tenants.list/2","type":"function"},{"doc":"Upserts the given tenant with the tenant data provided.","ref":"Knock.Tenants.html#set/3","title":"Knock.Tenants.set/3","type":"function"},{"doc":"Knock resources for accessing users","ref":"Knock.Users.html","title":"Knock.Users","type":"module"},{"doc":"Bulk deletes the list of users given. Can accept a maximum of 100 users at a time.","ref":"Knock.Users.html#bulk_delete/2","title":"Knock.Users.bulk_delete/2","type":"function"},{"doc":"Bulk identifies the list of users given. Can accept a maximum of 100 users at a time.","ref":"Knock.Users.html#bulk_identify/2","title":"Knock.Users.bulk_identify/2","type":"function"},{"doc":"Bulk sets the preferences given for the list of user ids. Will overwrite the any existing preferences for these users.","ref":"Knock.Users.html#bulk_set_preferences/4","title":"Knock.Users.bulk_set_preferences/4","type":"function"},{"doc":"Issues a delete request against the user specified","ref":"Knock.Users.html#delete/2","title":"Knock.Users.delete/2","type":"function"},{"doc":"Returns information about the user.","ref":"Knock.Users.html#get/2","title":"Knock.Users.get/2","type":"function"},{"doc":"Returns all of the users preference sets","ref":"Knock.Users.html#get_all_preferences/2","title":"Knock.Users.get_all_preferences/2","type":"function"},{"doc":"Returns user's channel data for the given channel id.","ref":"Knock.Users.html#get_channel_data/3","title":"Knock.Users.get_channel_data/3","type":"function"},{"doc":"Returns a feed for the user with the given channel_id. Optionally supports all of the options for fetching the feed. Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination - status: list of statuses to filter feed items with - tenant: tenant_id to filter messages with - has_tenant: optionally scope items by a tenant id or no tenant - archived: scope items by a given archived status (defaults to &quot;exclude&quot;) - trigger_data: trigger payload to filter feed items with","ref":"Knock.Users.html#get_feed/4","title":"Knock.Users.get_feed/4","type":"function"},{"doc":"Returns paginated messages for the given user Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination - status: list of statuses to filter messages with - tenant: tenant_id to filter messages with - channel_id: channel_id to filter messages with - source: workflow key to filter messages with - trigger_data: trigger payload to filter messages with","ref":"Knock.Users.html#get_messages/3","title":"Knock.Users.get_messages/3","type":"function"},{"doc":"Returns the preference set for the user.","ref":"Knock.Users.html#get_preferences/3","title":"Knock.Users.get_preferences/3","type":"function"},{"doc":"Returns paginated schedules for the given user Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination - tenant: tenant_id to filter messages with - workflow: workflow key to filter messages with","ref":"Knock.Users.html#get_schedules/3","title":"Knock.Users.get_schedules/3","type":"function"},{"doc":"Returns paginated subscriptions for the given user Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination","ref":"Knock.Users.html#get_subscriptions/3","title":"Knock.Users.get_subscriptions/3","type":"function"},{"doc":"Returns information about the user from the user_id given.","ref":"Knock.Users.html#get_user/2","title":"Knock.Users.get_user/2","type":"function"},{"doc":"Upserts the user specified via the user_id with the given properties.","ref":"Knock.Users.html#identify/3","title":"Knock.Users.identify/3","type":"function"},{"doc":"Returns paginated list of users Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination","ref":"Knock.Users.html#list/2","title":"Knock.Users.list/2","type":"function"},{"doc":"Merges the user specified with from_user_id into the user specified with user_id .","ref":"Knock.Users.html#merge/3","title":"Knock.Users.merge/3","type":"function"},{"doc":"Sets the category preferences for the user.","ref":"Knock.Users.html#set_categories_preferences/4","title":"Knock.Users.set_categories_preferences/4","type":"function"},{"doc":"Sets the category preference for the user.","ref":"Knock.Users.html#set_category_preferences/5","title":"Knock.Users.set_category_preferences/5","type":"function"},{"doc":"Upserts user's channel data for the given channel id.","ref":"Knock.Users.html#set_channel_data/4","title":"Knock.Users.set_channel_data/4","type":"function"},{"doc":"Sets the channel type preference for the user.","ref":"Knock.Users.html#set_channel_type_preferences/5","title":"Knock.Users.set_channel_type_preferences/5","type":"function"},{"doc":"Sets the channel type preferences for the user.","ref":"Knock.Users.html#set_channel_types_preferences/4","title":"Knock.Users.set_channel_types_preferences/4","type":"function"},{"doc":"Sets an entire preference set for the user. Will overwrite any existing data.","ref":"Knock.Users.html#set_preferences/4","title":"Knock.Users.set_preferences/4","type":"function"},{"doc":"Sets the workflow preference for the user.","ref":"Knock.Users.html#set_workflow_preferences/5","title":"Knock.Users.set_workflow_preferences/5","type":"function"},{"doc":"Sets the workflow preferences for the user.","ref":"Knock.Users.html#set_workflows_preferences/4","title":"Knock.Users.set_workflows_preferences/4","type":"function"},{"doc":"Unsets the user's channel data for the given channel id.","ref":"Knock.Users.html#unset_channel_data/3","title":"Knock.Users.unset_channel_data/3","type":"function"},{"doc":"Functions for interacting with Knock notify resources.","ref":"Knock.Workflows.html","title":"Knock.Workflows","type":"module"},{"doc":"Cancels the workflow with the given cancellation key. Can optionally be provided with: recipients : A list of recipients to cancel the notify for","ref":"Knock.Workflows.html#cancel/4","title":"Knock.Workflows.cancel/4","type":"function"},{"doc":"Creates schedule instances for the specified recipients on the properties map. Expected properties: recipients: list of recipients for schedules to be created for actor: actor to be used when trigger the target workflow repeats: repeat rules to specify when the workflow must be triggered data: data to be used as variables when the workflow runs tenant: tenant to be used for when the workflow runs","ref":"Knock.Workflows.html#create_schedules/3","title":"Knock.Workflows.create_schedules/3","type":"function"},{"doc":"Delete schedule instances.","ref":"Knock.Workflows.html#delete_schedules/2","title":"Knock.Workflows.delete_schedules/2","type":"function"},{"doc":"Returns paginated schedules for the provided environment Available optional parameters: # - page_size: specify size of the page to be returned by the api. (max limit: 50) - after: after cursor for pagination - before: before cursor for pagination - tenant: tenant_id to filter schedues with - recipients: list of recipients to filter schedules with","ref":"Knock.Workflows.html#list_schedules/3","title":"Knock.Workflows.list_schedules/3","type":"function"},{"doc":"Executes a notify call for the workflow with the given key. Note: properties must contain at least recipents for the call to be valid. Options can include: idempotency_key : A unique key to prevent duplicate requests","ref":"Knock.Workflows.html#trigger/4","title":"Knock.Workflows.trigger/4","type":"function"},{"doc":"Updates schedule instances with argument properties. Expected properties: actor: actor to be used when trigger the target workflow repeats: repeat rules to specify when the workflow must be triggered data: data to be used as variables when the workflow runs tenant: tenant to be used for when the workflow runs","ref":"Knock.Workflows.html#update_schedules/3","title":"Knock.Workflows.update_schedules/3","type":"function"},{"doc":"Exception for when a request is made without an API key.","ref":"Knock.ApiKeyMissingError.html","title":"Knock.ApiKeyMissingError","type":"exception"},{"doc":"Knock Knock API access for applications written in Elixir.","ref":"readme.html","title":"Knock","type":"extras"},{"doc":"See the package documentation as well as API documentation for usage examples.","ref":"readme.html#documentation","title":"Knock - Documentation","type":"extras"},{"doc":"Add the package to your mix.exs file as follows: def deps do [ { :knock , &quot;~&gt; 0.4&quot; } ] end","ref":"readme.html#installation","title":"Knock - Installation","type":"extras"},{"doc":"Start by defining an Elixir module for your Knock instance: defmodule MyApp.Knock do use Knock , otp_app : :my_app end To use the library you must provide a secret API key, provided in the Knock dashboard. You can set it as an environment variable: KNOCK_API_KEY=&quot;sk_12345&quot; Or you can specify it manually in your configuration: config :my_app , MyApp.Knock , api_key : &quot;sk_12345&quot; Or you can pass it through when creating a client instance: knock_client = MyApp.Knock . client ( api_key : &quot;sk_12345&quot; )","ref":"readme.html#configuration","title":"Knock - Configuration","type":"extras"},{"doc":"Identifying users MyApp.Knock . client ( ) |&gt; Knock.Users . identify ( &quot;jhammond&quot; , %{ &quot;name&quot; =&gt; &quot;John Hammond&quot; , &quot;email&quot; =&gt; &quot;jhammond@ingen.net&quot; , } ) Retrieving users MyApp.Knock . client ( ) |&gt; Knock.Users . get_user ( &quot;jhammond&quot; ) Sending notifies MyApp.Knock . client ( ) |&gt; Knock . notify ( &quot;dinosaurs-loose&quot; , %{ # user id of who performed the action &quot;actor&quot; =&gt; &quot;dnedry&quot; , # list of user ids for who should receive the notif &quot;recipients&quot; =&gt; [ &quot;jhammond&quot; , &quot;agrant&quot; , &quot;imalcolm&quot; , &quot;esattler&quot; ] , # an optional cancellation key &quot;cancellation_key&quot; =&gt; alert . id , # an optional tenant &quot;tenant&quot; =&gt; &quot;jurassic-park&quot; , # data payload to send through &quot;data&quot; =&gt; %{ &quot;type&quot; =&gt; &quot;trex&quot; , &quot;priority&quot; =&gt; 1 , } , } ) User preferences client = MyApp.Knock . client ( ) # Set preference set for user Knock.Users . set_preferences ( client , &quot;jhammond&quot; , %{ channel_types : %{ email : true } } ) # Set granular channel type preferences Knock.Users . set_channel_type_preferences ( client , &quot;jhammond&quot; , :email , true ) # Set granular workflow preferences Knock.Users . set_workflow_preferences ( client , &quot;jhammond&quot; , &quot;dinosaurs-loose&quot; , %{ channel_types : %{ email : true } } ) # Retrieve preferences Knock.Users . get_preferences ( client , &quot;jhammond&quot; ) Getting and setting channel data client = MyApp.Knock . client ( ) # Set channel data for an APNS Knock.Users . set_channel_data ( client , &quot;jhammond&quot; , KNOCK_APNS_CHANNEL_ID , %{ tokens : [ apns_token ] , } ) # Get channel data for the APNS channel Knock.Users . get_channel_data ( client , &quot;jhammond&quot; , KNOCK_APNS_CHANNEL_ID ) Canceling notifies MyApp.Knock . client ( ) |&gt; Knock.Workflows . cancel ( &quot;dinosaurs-loose&quot; , alert . id , %{ # optional list of user ids for who should have their notify canceled &quot;recipients&quot; =&gt; [ &quot;jhammond&quot; , &quot;agrant&quot; , &quot;imalcolm&quot; , &quot;esattler&quot; ] , } ) Signing JWTs You can use the excellent joken package to sign JWTs easily . You will need to generate an environment specific signing key, which you can find in the Knock dashboard. If you're using a signing token you will need to pass this to your client to perform authentication. You can read more about clientside authentication here . priv = System . get_env ( &quot;KNOCK_SIGNING_KEY&quot; ) now = DateTime . utc_now ( ) claims = %{ # The user id to sign this key for &quot;sub&quot; =&gt; user_id , # When the token was issued &quot;iat&quot; =&gt; DateTime . to_unix ( now ) , # When the token expires (1 hour) &quot;exp&quot; =&gt; DateTime . add ( now , 3600 , :second ) |&gt; DateTime . to_unix ( ) } signer = Joken.Signer . create ( &quot;RS256&quot; , %{ &quot;pem&quot; =&gt; priv } ) { :ok , token , _ } = Joken . generate_and_sign ( %{ } , claims , signer )","ref":"readme.html#usage","title":"Knock - Usage","type":"extras"},{"doc":"MIT License Copyright (c) 2021 Knock Labs, Inc. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]